package xyz.tbvns.rogue_block.client.Gui;

import io.wispforest.owo.ui.component.Components;
import io.wispforest.owo.ui.container.FlowLayout;
import io.wispforest.owo.ui.container.GridLayout;
import io.wispforest.owo.ui.core.Component;
import io.wispforest.owo.ui.core.ParentComponent;
import io.wispforest.owo.ui.core.Positioning;
import io.wispforest.owo.ui.core.Sizing;
import io.wispforest.owo.ui.event.MouseEnter;
import lombok.AllArgsConstructor;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Identifier;
import xyz.tbvns.rogue_block.Upgrades.UpgradeRarity;
import xyz.tbvns.rogue_block.Utils;

public class UpgradeComponent {
    ItemStack stack;
    UpgradeRarity rarity;
    double x, y;
    boolean isHovered = false;

    Component textureComponent;
    Component itemComponent;

    public UpgradeComponent(ItemStack stack, UpgradeRarity rarity, int posX, int posY) {
        this.stack = stack;
        this.rarity = rarity;
        x = posX; y = posY;
    }

    public void add(FlowLayout layout) {
        Component item = Components.item(stack);
        item.positioning().set(Positioning.absolute((int) x, (int) y));
        Component component = getTextureComponent(rarity.unobtained, item);

        layout.child(component);
        layout.child(item);

        textureComponent = component;
        itemComponent = item;
    }

    public Component getTextureComponent(Identifier identifier, Component item) {
        Component component =
            Components.texture(
                    identifier,
                    1, 1, 256, 256
            ).sizing(
                    Sizing.fixed(21),
                    Sizing.fixed(21)
            );
        component.positioning().set(Positioning.absolute((int) (x - 2), (int) (y - 2)));
        UpgradeScreen.update();

        component.mouseEnter().subscribe(() -> {
            component.sizing(Sizing.fixed(25), Sizing.fixed(25));
            item.sizing(Sizing.fixed(20), Sizing.fixed(20));
            isHovered = true;

            UpgradeScreen.update();
        });

        component.mouseLeave().subscribe(() -> {
            component.sizing(Sizing.fixed(21), Sizing.fixed(21));
            item.sizing(Sizing.fixed(16), Sizing.fixed(16));
            isHovered = false;

            UpgradeScreen.update();
        });

        component.mouseDown().subscribe((mouseX, mouseY, button) -> {
            ParentComponent parentComponent = textureComponent.root();
            textureComponent.remove();
            FlowLayout layout = (FlowLayout) parentComponent;
            textureComponent = getTextureComponent(rarity.obtained, item);
            layout.child(textureComponent);
            return true;
        });
        return component;
    }
}
